/* Indicator.c generated by valac 0.54.8, the Vala compiler
 * generated from Indicator.vala, do not modify */

/*
* Copyright (c) 2015-2018 elementary LLC (http://launchpad.net/wingpanel-indicator-network)
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU Library General Public License as published by
* the Free Software Foundation, either version 2.1 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Library General Public License for more details.
*
* You should have received a copy of the GNU Library General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*
*/

#include "network.h"
#include <gio/gio.h>
#include <glib.h>
#include <wingpanel.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gdesktopappinfo.h>
#include <gmodule.h>

enum  {
	NETWORK_INDICATOR_0_PROPERTY,
	NETWORK_INDICATOR_IS_IN_SESSION_PROPERTY,
	NETWORK_INDICATOR_NUM_PROPERTIES
};
static GParamSpec* network_indicator_properties[NETWORK_INDICATOR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _NetworkIndicatorPrivate {
	NetworkWidgetsDisplayWidget* display_widget;
	NetworkWidgetsPopoverWidget* popover_widget;
	GNetworkMonitor* network_monitor;
	gboolean _is_in_session;
};

static gint NetworkIndicator_private_offset;
static gpointer network_indicator_parent_class = NULL;

static void network_indicator_on_state_changed (NetworkIndicator* self);
static void _network_indicator_on_state_changed_g_object_notify (GObject* _sender,
                                                          GParamSpec* pspec,
                                                          gpointer self);
static void __lambda38_ (NetworkIndicator* self);
static void ___lambda38__network_widgets_popover_widget_settings_shown (NetworkWidgetsPopoverWidget* _sender,
                                                                 gpointer self);
static void network_indicator_update_tooltip (NetworkIndicator* self);
static void network_indicator_start_monitor (NetworkIndicator* self);
static GtkWidget* network_indicator_real_get_display_widget (WingpanelIndicator* base);
static GtkWidget* network_indicator_real_get_widget (WingpanelIndicator* base);
static void __lambda39_ (NetworkIndicator* self,
                  gboolean availabe);
static void ___lambda39__g_network_monitor_network_changed (GNetworkMonitor* _sender,
                                                     gboolean network_available,
                                                     gpointer self);
static void network_indicator_real_opened (WingpanelIndicator* base);
static void network_indicator_real_closed (WingpanelIndicator* base);
static gchar* network_indicator_get_active_wired_name (NetworkIndicator* self);
static gchar* network_indicator_get_active_wifi_name (NetworkIndicator* self);
static void network_indicator_finalize (GObject * obj);
static GType network_indicator_get_type_once (void);
static void _vala_network_indicator_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
static void _vala_network_indicator_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec);

static inline gpointer
network_indicator_get_instance_private (NetworkIndicator* self)
{
	return G_STRUCT_MEMBER_P (self, NetworkIndicator_private_offset);
}

static void
_network_indicator_on_state_changed_g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self)
{
	network_indicator_on_state_changed ((NetworkIndicator*) self);
}

static void
__lambda38_ (NetworkIndicator* self)
{
	g_signal_emit_by_name ((WingpanelIndicator*) self, "close");
}

static void
___lambda38__network_widgets_popover_widget_settings_shown (NetworkWidgetsPopoverWidget* _sender,
                                                            gpointer self)
{
	__lambda38_ ((NetworkIndicator*) self);
}

NetworkIndicator*
network_indicator_construct (GType object_type,
                             gboolean is_in_session)
{
	NetworkIndicator * self = NULL;
	NetworkWidgetsDisplayWidget* _tmp0_;
	NetworkWidgetsPopoverWidget* _tmp1_;
	NetworkWidgetsPopoverWidget* _tmp2_;
	NetworkWidgetsPopoverWidget* _tmp3_;
	NetworkWidgetsPopoverWidget* _tmp4_;
	NetworkWidgetsPopoverWidget* _tmp5_;
	bindtextdomain (GETTEXT_PACKAGE, LOCALEDIR);
	bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
	self = (NetworkIndicator*) g_object_new (object_type, "code-name", WINGPANEL_INDICATOR_NETWORK, "is-in-session", is_in_session, "visible", TRUE, NULL);
	_tmp0_ = network_widgets_display_widget_new ();
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->priv->display_widget);
	self->priv->display_widget = _tmp0_;
	_tmp1_ = network_widgets_popover_widget_new (is_in_session);
	g_object_ref_sink (_tmp1_);
	_g_object_unref0 (self->priv->popover_widget);
	self->priv->popover_widget = _tmp1_;
	_tmp2_ = self->priv->popover_widget;
	g_signal_connect_object ((GObject*) _tmp2_, "notify::state", (GCallback) _network_indicator_on_state_changed_g_object_notify, self, 0);
	_tmp3_ = self->priv->popover_widget;
	g_signal_connect_object ((GObject*) _tmp3_, "notify::secure", (GCallback) _network_indicator_on_state_changed_g_object_notify, self, 0);
	_tmp4_ = self->priv->popover_widget;
	g_signal_connect_object ((GObject*) _tmp4_, "notify::extra-info", (GCallback) _network_indicator_on_state_changed_g_object_notify, self, 0);
	_tmp5_ = self->priv->popover_widget;
	g_signal_connect_object (_tmp5_, "settings-shown", (GCallback) ___lambda38__network_widgets_popover_widget_settings_shown, self, 0);
	network_indicator_update_tooltip (self);
	network_indicator_on_state_changed (self);
	network_indicator_start_monitor (self);
	return self;
}

NetworkIndicator*
network_indicator_new (gboolean is_in_session)
{
	return network_indicator_construct (NETWORK_TYPE_INDICATOR, is_in_session);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static GtkWidget*
network_indicator_real_get_display_widget (WingpanelIndicator* base)
{
	NetworkIndicator * self;
	NetworkWidgetsDisplayWidget* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* result = NULL;
	self = (NetworkIndicator*) base;
	_tmp0_ = self->priv->display_widget;
	_tmp1_ = _g_object_ref0 ((GtkWidget*) _tmp0_);
	result = _tmp1_;
	return result;
}

static GtkWidget*
network_indicator_real_get_widget (WingpanelIndicator* base)
{
	NetworkIndicator * self;
	NetworkWidgetsPopoverWidget* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* result = NULL;
	self = (NetworkIndicator*) base;
	_tmp0_ = self->priv->popover_widget;
	_tmp1_ = _g_object_ref0 ((GtkWidget*) _tmp0_);
	result = _tmp1_;
	return result;
}

static void
network_indicator_on_state_changed (NetworkIndicator* self)
{
	NetworkWidgetsPopoverWidget* _tmp0_;
	NetworkWidgetsDisplayWidget* _tmp1_;
	NetworkWidgetsDisplayWidget* _tmp2_;
	NetworkWidgetsPopoverWidget* _tmp3_;
	NetworkState _tmp4_;
	NetworkState _tmp5_;
	NetworkWidgetsPopoverWidget* _tmp6_;
	gboolean _tmp7_;
	gboolean _tmp8_;
	NetworkWidgetsPopoverWidget* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->popover_widget;
	_vala_assert (_tmp0_ != NULL, "popover_widget != null");
	_tmp1_ = self->priv->display_widget;
	_vala_assert (_tmp1_ != NULL, "display_widget != null");
	_tmp2_ = self->priv->display_widget;
	_tmp3_ = self->priv->popover_widget;
	_tmp4_ = network_widgets_popover_widget_get_state (_tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = self->priv->popover_widget;
	_tmp7_ = network_widgets_popover_widget_get_secure (_tmp6_);
	_tmp8_ = _tmp7_;
	_tmp9_ = self->priv->popover_widget;
	_tmp10_ = network_widgets_popover_widget_get_extra_info (_tmp9_);
	_tmp11_ = _tmp10_;
	network_widgets_display_widget_update_state (_tmp2_, _tmp5_, _tmp8_, _tmp11_);
	network_indicator_update_tooltip (self);
}

static void
__lambda39_ (NetworkIndicator* self,
             gboolean availabe)
{
	gboolean _tmp0_;
	GNetworkMonitor* _tmp1_;
	GError* _inner_error0_ = NULL;
	_tmp0_ = self->priv->_is_in_session;
	if (!_tmp0_) {
		return;
	}
	_tmp1_ = self->priv->network_monitor;
	if (g_network_monitor_get_connectivity (_tmp1_) == G_NETWORK_CONNECTIVITY_PORTAL) {
		{
			GDesktopAppInfo* appinfo = NULL;
			GDesktopAppInfo* _tmp2_;
			GDesktopAppInfo* _tmp3_;
			_tmp2_ = g_desktop_app_info_new ("io.elementary.capnet-assist.desktop");
			appinfo = _tmp2_;
			_tmp3_ = appinfo;
			g_app_info_launch ((GAppInfo*) _tmp3_, NULL, NULL, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_object_unref0 (appinfo);
				goto __catch0_g_error;
			}
			_g_object_unref0 (appinfo);
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp4_;
			const gchar* _tmp5_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp4_ = e;
			_tmp5_ = _tmp4_->message;
			g_warning ("Indicator.vala:78: %s", _tmp5_);
			_g_error_free0 (e);
		}
		__finally0:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	network_indicator_update_tooltip (self);
}

static void
___lambda39__g_network_monitor_network_changed (GNetworkMonitor* _sender,
                                                gboolean network_available,
                                                gpointer self)
{
	__lambda39_ ((NetworkIndicator*) self, network_available);
}

static void
network_indicator_start_monitor (NetworkIndicator* self)
{
	GNetworkMonitor* _tmp0_;
	GNetworkMonitor* _tmp1_;
	GNetworkMonitor* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_network_monitor_get_default ();
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->network_monitor);
	self->priv->network_monitor = _tmp1_;
	_tmp2_ = self->priv->network_monitor;
	g_signal_connect_object (_tmp2_, "network-changed", (GCallback) ___lambda39__g_network_monitor_network_changed, self, 0);
}

static void
network_indicator_real_opened (WingpanelIndicator* base)
{
	NetworkIndicator * self;
	NetworkWidgetsPopoverWidget* _tmp0_;
	self = (NetworkIndicator*) base;
	_tmp0_ = self->priv->popover_widget;
	if (_tmp0_ != NULL) {
		NetworkWidgetsPopoverWidget* _tmp1_;
		_tmp1_ = self->priv->popover_widget;
		network_widgets_popover_widget_opened (_tmp1_);
	}
}

static void
network_indicator_real_closed (WingpanelIndicator* base)
{
	NetworkIndicator * self;
	NetworkWidgetsPopoverWidget* _tmp0_;
	self = (NetworkIndicator*) base;
	_tmp0_ = self->priv->popover_widget;
	if (_tmp0_ != NULL) {
		NetworkWidgetsPopoverWidget* _tmp1_;
		_tmp1_ = self->priv->popover_widget;
		network_widgets_popover_widget_closed (_tmp1_);
	}
}

static void
network_indicator_update_tooltip (NetworkIndicator* self)
{
	NetworkWidgetsPopoverWidget* _tmp0_;
	NetworkState _tmp1_;
	NetworkState _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->popover_widget;
	_tmp1_ = network_widgets_popover_widget_get_state (_tmp0_);
	_tmp2_ = _tmp1_;
	switch (_tmp2_) {
		case NETWORK_STATE_CONNECTING_WIRED:
		{
			gchar* active_wired_name = NULL;
			gchar* _tmp3_;
			const gchar* _tmp4_;
			_tmp3_ = network_indicator_get_active_wired_name (self);
			active_wired_name = _tmp3_;
			_tmp4_ = active_wired_name;
			if (g_strcmp0 (_tmp4_, _ ("Wired")) == 0) {
				NetworkWidgetsDisplayWidget* _tmp5_;
				_tmp5_ = self->priv->display_widget;
				gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp5_, _ ("Connecting to wired network"));
			} else {
				NetworkWidgetsDisplayWidget* _tmp6_;
				const gchar* _tmp7_;
				gchar* _tmp8_;
				gchar* _tmp9_;
				_tmp6_ = self->priv->display_widget;
				_tmp7_ = active_wired_name;
				_tmp8_ = g_strdup_printf (_ ("Connecting to “%s”"), _tmp7_);
				_tmp9_ = _tmp8_;
				gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp6_, _tmp9_);
				_g_free0 (_tmp9_);
			}
			_g_free0 (active_wired_name);
			break;
		}
		case NETWORK_STATE_CONNECTING_WIFI:
		case NETWORK_STATE_CONNECTING_MOBILE:
		{
			NetworkWidgetsDisplayWidget* _tmp10_;
			gchar* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
			gchar* _tmp14_;
			_tmp10_ = self->priv->display_widget;
			_tmp11_ = network_indicator_get_active_wifi_name (self);
			_tmp12_ = _tmp11_;
			_tmp13_ = g_strdup_printf (_ ("Connecting to “%s”"), _tmp12_);
			_tmp14_ = _tmp13_;
			gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp10_, _tmp14_);
			_g_free0 (_tmp14_);
			_g_free0 (_tmp12_);
			break;
		}
		case NETWORK_STATE_CONNECTED_WIRED:
		{
			gchar* active_wired_name = NULL;
			gchar* _tmp15_;
			const gchar* _tmp16_;
			_tmp15_ = network_indicator_get_active_wired_name (self);
			active_wired_name = _tmp15_;
			_tmp16_ = active_wired_name;
			if (g_strcmp0 (_tmp16_, _ ("Wired")) == 0) {
				NetworkWidgetsDisplayWidget* _tmp17_;
				_tmp17_ = self->priv->display_widget;
				gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp17_, _ ("Connected to wired network"));
			} else {
				NetworkWidgetsDisplayWidget* _tmp18_;
				const gchar* _tmp19_;
				gchar* _tmp20_;
				gchar* _tmp21_;
				_tmp18_ = self->priv->display_widget;
				_tmp19_ = active_wired_name;
				_tmp20_ = g_strdup_printf (_ ("Connected to “%s”"), _tmp19_);
				_tmp21_ = _tmp20_;
				gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp18_, _tmp21_);
				_g_free0 (_tmp21_);
			}
			_g_free0 (active_wired_name);
			break;
		}
		case NETWORK_STATE_CONNECTED_WIFI_WEAK:
		case NETWORK_STATE_CONNECTED_WIFI_OK:
		case NETWORK_STATE_CONNECTED_WIFI_GOOD:
		case NETWORK_STATE_CONNECTED_WIFI_EXCELLENT:
		case NETWORK_STATE_CONNECTED_MOBILE_WEAK:
		case NETWORK_STATE_CONNECTED_MOBILE_OK:
		case NETWORK_STATE_CONNECTED_MOBILE_GOOD:
		case NETWORK_STATE_CONNECTED_MOBILE_EXCELLENT:
		{
			NetworkWidgetsDisplayWidget* _tmp22_;
			gchar* _tmp23_;
			gchar* _tmp24_;
			gchar* _tmp25_;
			gchar* _tmp26_;
			_tmp22_ = self->priv->display_widget;
			_tmp23_ = network_indicator_get_active_wifi_name (self);
			_tmp24_ = _tmp23_;
			_tmp25_ = g_strdup_printf (_ ("Connected to “%s”"), _tmp24_);
			_tmp26_ = _tmp25_;
			gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp22_, _tmp26_);
			_g_free0 (_tmp26_);
			_g_free0 (_tmp24_);
			break;
		}
		case NETWORK_STATE_FAILED:
		case NETWORK_STATE_FAILED_WIFI:
		case NETWORK_STATE_FAILED_MOBILE:
		{
			NetworkWidgetsDisplayWidget* _tmp27_;
			_tmp27_ = self->priv->display_widget;
			gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp27_, _ ("Failed to connect"));
			break;
		}
		case NETWORK_STATE_DISCONNECTED:
		case NETWORK_STATE_DISCONNECTED_AIRPLANE_MODE:
		{
			NetworkWidgetsDisplayWidget* _tmp28_;
			_tmp28_ = self->priv->display_widget;
			gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp28_, _ ("Disconnected"));
			break;
		}
		default:
		{
			NetworkWidgetsDisplayWidget* _tmp29_;
			_tmp29_ = self->priv->display_widget;
			gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp29_, _ ("Not connected"));
			break;
		}
	}
}

static gchar*
network_indicator_get_active_wired_name (NetworkIndicator* self)
{
	NetworkWidgetsPopoverWidget* _tmp0_;
	GtkBox* _tmp1_;
	GtkBox* _tmp2_;
	GList* _tmp3_;
	gchar* _tmp12_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->popover_widget;
	_tmp1_ = network_widgets_popover_widget_get_other_box (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = gtk_container_get_children ((GtkContainer*) _tmp2_);
	{
		GList* child_collection = NULL;
		GList* child_it = NULL;
		child_collection = _tmp3_;
		for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
			GtkWidget* child = NULL;
			child = (GtkWidget*) child_it->data;
			{
				GtkWidget* _tmp4_;
				_tmp4_ = child;
				if (NETWORK_IS_ETHER_INTERFACE (_tmp4_)) {
					gchar* active_wired_name = NULL;
					GtkWidget* _tmp5_;
					const gchar* _tmp6_;
					const gchar* _tmp7_;
					gchar* _tmp8_;
					const gchar* _tmp9_;
					gchar* _tmp10_;
					gchar* _tmp11_;
					_tmp5_ = child;
					_tmp6_ = network_widget_nm_interface_get_display_title ((NetworkWidgetNMInterface*) G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, NETWORK_TYPE_ETHER_INTERFACE, NetworkEtherInterface));
					_tmp7_ = _tmp6_;
					_tmp8_ = g_strdup (_tmp7_);
					active_wired_name = _tmp8_;
					_tmp9_ = active_wired_name;
					_tmp10_ = g_strdup_printf ("Active network (Wired): %s", _tmp9_);
					_tmp11_ = _tmp10_;
					g_debug ("Indicator.vala:157: %s", _tmp11_);
					_g_free0 (_tmp11_);
					result = active_wired_name;
					(child_collection == NULL) ? NULL : (child_collection = (g_list_free (child_collection), NULL));
					return result;
				}
			}
		}
		(child_collection == NULL) ? NULL : (child_collection = (g_list_free (child_collection), NULL));
	}
	_tmp12_ = g_strdup (_ ("unknown network"));
	result = _tmp12_;
	return result;
}

static gchar*
network_indicator_get_active_wifi_name (NetworkIndicator* self)
{
	NetworkWidgetsPopoverWidget* _tmp0_;
	GtkBox* _tmp1_;
	GtkBox* _tmp2_;
	GList* _tmp3_;
	gchar* _tmp12_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->popover_widget;
	_tmp1_ = network_widgets_popover_widget_get_wifi_box (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = gtk_container_get_children ((GtkContainer*) _tmp2_);
	{
		GList* child_collection = NULL;
		GList* child_it = NULL;
		child_collection = _tmp3_;
		for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
			GtkWidget* child = NULL;
			child = (GtkWidget*) child_it->data;
			{
				GtkWidget* _tmp4_;
				_tmp4_ = child;
				if (NETWORK_IS_WIFI_INTERFACE (_tmp4_)) {
					gchar* active_wifi_name = NULL;
					GtkWidget* _tmp5_;
					const gchar* _tmp6_;
					const gchar* _tmp7_;
					gchar* _tmp8_;
					const gchar* _tmp9_;
					gchar* _tmp10_;
					gchar* _tmp11_;
					_tmp5_ = child;
					_tmp6_ = network_wifi_interface_get_active_ap_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, NETWORK_TYPE_WIFI_INTERFACE, NetworkWifiInterface));
					_tmp7_ = _tmp6_;
					_tmp8_ = g_strdup (_tmp7_);
					active_wifi_name = _tmp8_;
					_tmp9_ = active_wifi_name;
					_tmp10_ = g_strdup_printf ("Active network (WiFi): %s", _tmp9_);
					_tmp11_ = _tmp10_;
					g_debug ("Indicator.vala:169: %s", _tmp11_);
					_g_free0 (_tmp11_);
					result = active_wifi_name;
					(child_collection == NULL) ? NULL : (child_collection = (g_list_free (child_collection), NULL));
					return result;
				}
			}
		}
		(child_collection == NULL) ? NULL : (child_collection = (g_list_free (child_collection), NULL));
	}
	_tmp12_ = g_strdup (_ ("unknown network"));
	result = _tmp12_;
	return result;
}

gboolean
network_indicator_get_is_in_session (NetworkIndicator* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_is_in_session;
	return result;
}

void
network_indicator_set_is_in_session (NetworkIndicator* self,
                                     gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = network_indicator_get_is_in_session (self);
	if (old_value != value) {
		self->priv->_is_in_session = value;
		g_object_notify_by_pspec ((GObject *) self, network_indicator_properties[NETWORK_INDICATOR_IS_IN_SESSION_PROPERTY]);
	}
}

static void
network_indicator_class_init (NetworkIndicatorClass * klass,
                              gpointer klass_data)
{
	network_indicator_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &NetworkIndicator_private_offset);
	((WingpanelIndicatorClass *) klass)->get_display_widget = (GtkWidget* (*) (WingpanelIndicator*)) network_indicator_real_get_display_widget;
	((WingpanelIndicatorClass *) klass)->get_widget = (GtkWidget* (*) (WingpanelIndicator*)) network_indicator_real_get_widget;
	((WingpanelIndicatorClass *) klass)->opened = (void (*) (WingpanelIndicator*)) network_indicator_real_opened;
	((WingpanelIndicatorClass *) klass)->closed = (void (*) (WingpanelIndicator*)) network_indicator_real_closed;
	G_OBJECT_CLASS (klass)->get_property = _vala_network_indicator_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_network_indicator_set_property;
	G_OBJECT_CLASS (klass)->finalize = network_indicator_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_INDICATOR_IS_IN_SESSION_PROPERTY, network_indicator_properties[NETWORK_INDICATOR_IS_IN_SESSION_PROPERTY] = g_param_spec_boolean ("is-in-session", "is-in-session", "is-in-session", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
network_indicator_instance_init (NetworkIndicator * self,
                                 gpointer klass)
{
	self->priv = network_indicator_get_instance_private (self);
	self->priv->display_widget = NULL;
	self->priv->popover_widget = NULL;
	self->priv->_is_in_session = FALSE;
}

static void
network_indicator_finalize (GObject * obj)
{
	NetworkIndicator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NETWORK_TYPE_INDICATOR, NetworkIndicator);
	_g_object_unref0 (self->priv->display_widget);
	_g_object_unref0 (self->priv->popover_widget);
	_g_object_unref0 (self->priv->network_monitor);
	G_OBJECT_CLASS (network_indicator_parent_class)->finalize (obj);
}

static GType
network_indicator_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (NetworkIndicatorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) network_indicator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NetworkIndicator), 0, (GInstanceInitFunc) network_indicator_instance_init, NULL };
	GType network_indicator_type_id;
	network_indicator_type_id = g_type_register_static (WINGPANEL_TYPE_INDICATOR, "NetworkIndicator", &g_define_type_info, 0);
	NetworkIndicator_private_offset = g_type_add_instance_private (network_indicator_type_id, sizeof (NetworkIndicatorPrivate));
	return network_indicator_type_id;
}

GType
network_indicator_get_type (void)
{
	static volatile gsize network_indicator_type_id__volatile = 0;
	if (g_once_init_enter (&network_indicator_type_id__volatile)) {
		GType network_indicator_type_id;
		network_indicator_type_id = network_indicator_get_type_once ();
		g_once_init_leave (&network_indicator_type_id__volatile, network_indicator_type_id);
	}
	return network_indicator_type_id__volatile;
}

static void
_vala_network_indicator_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	NetworkIndicator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETWORK_TYPE_INDICATOR, NetworkIndicator);
	switch (property_id) {
		case NETWORK_INDICATOR_IS_IN_SESSION_PROPERTY:
		g_value_set_boolean (value, network_indicator_get_is_in_session (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_network_indicator_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec)
{
	NetworkIndicator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETWORK_TYPE_INDICATOR, NetworkIndicator);
	switch (property_id) {
		case NETWORK_INDICATOR_IS_IN_SESSION_PROPERTY:
		network_indicator_set_is_in_session (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

WingpanelIndicator*
get_indicator (GModule* module,
               WingpanelIndicatorManagerServerType server_type)
{
	NetworkIndicator* indicator = NULL;
	NetworkIndicator* _tmp0_;
	WingpanelIndicator* result = NULL;
	g_return_val_if_fail (module != NULL, NULL);
	g_debug ("Indicator.vala:179: Activating Network Indicator");
	_tmp0_ = network_indicator_new (server_type == WINGPANEL_INDICATOR_MANAGER_SERVER_TYPE_SESSION);
	indicator = _tmp0_;
	result = (WingpanelIndicator*) indicator;
	return result;
}

